/***************************************************************************
 *   Copyright (C) 2007 by Antony Martin                                   *
 *   martin.antony@yahoo.fr                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* Cree le : 6 mars 2006
   derniere modification le 16/03/2007 */


/* fichier en-tete de redefinition des types GL et de definition des types
   de base et constantes propres au SCEngine */



#ifndef __SCECTYPES_H__
#define __SCECTYPES_H__


/* NOTE: les en-tetes des APIs sont a inclure au dossier core/ */
/* inclusion des en-tetes des APIs */
/* c'est plutot moche mais c'est relativement obligatoire pour que la conversion
   des constantes et des types a coups de defines fonctionne correctement */
#include <GL/glew.h>
#include <IL/il.h>
#include <IL/ilu.h>

#ifdef _SCE_USE_CG
 #include <Cg/cg.h>
 #include <Cg/cgGL.h>
#endif

/* (re)definition des types du SCEngine */
typedef unsigned int    SCEflags;
typedef GLenum          SCEenum;
typedef GLbitfield      SCEbitfield;
typedef GLint           SCEint;
typedef GLuint          SCEuint;
typedef GLfloat         SCEfloat;
typedef GLdouble        SCEdouble;


/* contantes que peuvent renvoyer les fonctions du coeur du SCEngine */
#define SCE_OK 0
#define SCE_TRUE 1
#define SCE_FALSE 0
#define SCE_ERROR -1


/* flags d'initialisation de coeur */
#define SCE_USE_CG_SHADERS (0x0000000f)


/* ---> conversion de nom (NOTE: a completer) */
/* types de variable */
#define SCE_BYTE            GL_BYTE
#define SCE_UNSIGNED_BYTE   GL_UNSIGNED_BYTE
#define SCE_SHORT           GL_SHORT
#define SCE_UNSIGNED_SHORT  GL_UNSIGNED_SHORT
#define SCE_INT             GL_INT
#define SCE_UNSIGNED_INT    GL_UNSIGNED_INT
#define SCE_FLOAT           GL_FLOAT
#define SCE_DOUBLE          GL_DOUBLE

/* types de polygone */
#define SCE_POINTS          GL_POINTS
#define SCE_LINES           GL_LINES
#define SCE_LINE_LOOP       GL_LINE_LOOP
#define SCE_LINE_STRIP      GL_LINE_STRIP
#define SCE_TRIANGLES       GL_TRIANGLES
#define SCE_TRIANGLE_STRIP  GL_TRIANGLE_STRIP
#define SCE_TRIANGLE_FAN    GL_TRIANGLE_FAN
#define SCE_QUADS           GL_QUADS
#define SCE_QUAD_STRIP      GL_QUAD_STRIP
#define SCE_POLYGON         GL_POLYGON

/* unites de texture */
#define SCE_TEX             GL_TEXTURE  /* matrice non ? */
#define SCE_TEX0            GL_TEXTURE0
#define SCE_TEX1            GL_TEXTURE1
#define SCE_TEX2            GL_TEXTURE2
#define SCE_TEX3            GL_TEXTURE3
#define SCE_TEX4            GL_TEXTURE4
#define SCE_TEX5            GL_TEXTURE5
#define SCE_TEX6            GL_TEXTURE6
#define SCE_TEX7            GL_TEXTURE7
#define SCE_TEX8            GL_TEXTURE8
#define SCE_TEX9            GL_TEXTURE9
#define SCE_TEX10           GL_TEXTURE10
#define SCE_TEX11           GL_TEXTURE11
/* types de texture */
#define SCE_TEX_1D          GL_TEXTURE_1D
#define SCE_TEX_2D          GL_TEXTURE_2D
#define SCE_TEX_3D          GL_TEXTURE_3D
#define SCE_TEX_CUBE        GL_TEXTURE_CUBE_MAP
#define SCE_TEX_POSX        GL_TEXTURE_CUBE_MAP_POSITIVE_X
#define SCE_TEX_NEGX        GL_TEXTURE_CUBE_MAP_NEGATIVE_X
#define SCE_TEX_POSY        GL_TEXTURE_CUBE_MAP_POSITIVE_Y
#define SCE_TEX_NEGY        GL_TEXTURE_CUBE_MAP_NEGATIVE_Y
#define SCE_TEX_POSZ        GL_TEXTURE_CUBE_MAP_POSITIVE_Z
#define SCE_TEX_NEGZ        GL_TEXTURE_CUBE_MAP_NEGATIVE_Z
/* filtrage des textures */
#define SCE_TEX_NEAREST     GL_NEAREST
#define SCE_TEX_LINEAR      GL_LINEAR
#define SCE_TEX_BILINEAR    GL_LINEAR_MIPMAP_NEAREST
#define SCE_TEX_TRILINEAR   GL_LINEAR_MIPMAP_LINEAR
#define SCE_TEX_MAG_FILTER  GL_TEXTURE_MAG_FILTER
#define SCE_TEX_MIN_FILTER  GL_TEXTURE_MIN_FILTER

/* ... */


/* retourne la taille en octets d'un type d'opengl */
size_t SCE_CSizeofType(SCEenum);

/* retourne le nombre maximal d'unite de texture */
unsigned int SCE_CGetGLMaxTextureUnits(void);


#endif /* guard */
